package ch.unige.solidify.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.model.User;
import ch.unige.solidify.service.SsoUserService;

@RestController
public class SsoUserController {
  @Autowired
  private SsoUserService ssoUserService;

  /**
   * Returns user data provided by the SSO for the current user.
   *
   * @return User's sso data
   */
  @GetMapping("/sso-user")
  public User user() {
    return this.ssoUserService.current();
  }
}