package ch.unige.solidify.service;

import java.security.Principal;

import javax.servlet.http.HttpServletRequest;

import org.springframework.context.annotation.Scope;
import org.springframework.context.annotation.ScopedProxyMode;
import org.springframework.stereotype.Component;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.context.WebApplicationContext;

@Component
@Scope(value = WebApplicationContext.SCOPE_REQUEST, proxyMode = ScopedProxyMode.TARGET_CLASS)
public class AuthenticationStorageImpl implements AuthenticationStorage {

  protected static final String AUTHORIZATION_HEADER = "Authorization";

  private final MultiValueMap<String, String> authorizationHeaders = new LinkedMultiValueMap<>();

  private Principal principal = null;

  public MultiValueMap<String, String> getHeadersWithAuthorization() {
    return this.authorizationHeaders;
  }

  public Principal getPrincipal() {
    return this.principal;
  }

  public void storeAuthentication(Principal principal, HttpServletRequest request) {
    if (principal != null) {
      this.principal = principal;
      this.authorizationHeaders.add(AUTHORIZATION_HEADER, request.getHeader(AUTHORIZATION_HEADER));
    }
  }
}
