package ch.unige.solidify.validation;

import static java.lang.annotation.ElementType.ANNOTATION_TYPE;
import static java.lang.annotation.ElementType.FIELD;
import static java.lang.annotation.ElementType.TYPE;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import javax.validation.Constraint;
import javax.validation.Payload;

@Target({ TYPE, ANNOTATION_TYPE, FIELD })
@Retention(RUNTIME)
@Constraint(validatedBy = AssertThatAnotherFieldHasValueValidator.class)
@Documented
public @interface AssertThatAnotherFieldHasValue {

  @Target({ TYPE, ANNOTATION_TYPE, FIELD })
  @Retention(RUNTIME)
  @Documented
  @interface List {
    AssertThatAnotherFieldHasValue[] value();
  }

  String dependFieldName();

  String fieldName();

  String fieldValue();

  Class<?>[] groups() default {};

  String message() default "{message.validator.assert.another.field.has.value}";

  Class<? extends Payload>[] payload() default {};
}
